/*
 SignaturePad: A jQuery plugin for assisting in the creation of an HTML5 canvas
 based signature pad. Records the drawn signature in JSON for later regeneration.

 Dependencies: FlashCanvas/1.5, json2, jquery/1.3.2+

 @project ca.thomasjbradley.applications.signaturepad
 @author Thomas J Bradley <hey@thomasjbradley.ca>
 @link http://thomasjbradley.ca/lab/signature-pad
 @link http://github.com/thomasjbradley/signature-pad
 @copyright Copyright MMXI, Thomas J Bradley
 @license New BSD License
 @version {{version}}
*/
(function(b){function u(r,p){var k,l;function s(d,c){var e=b(d.target).offset(),f;clearTimeout(n);n=false;typeof d.changedTouches!=="undefined"?(f=Math.floor(d.changedTouches[0].pageX-e.left),e=Math.floor(d.changedTouches[0].pageY-e.top)):(f=Math.floor(d.pageX-e.left),e=Math.floor(d.pageY-e.top));if(k===f&&l===e)return true;k===null&&(k=f);l===null&&(l=e);c&&(e+=c);g.beginPath();g.moveTo(k,l);g.lineTo(f,e);g.lineCap=a.penCap;g.stroke();g.closePath();j.push({lx:f,ly:e,mx:k,my:l});k=f;l=e}function m(){q?
h.each(function(){this.ontouchmove=null}):h.unbind("mousemove.signaturepad");l=k=null;j.length>0&&b(a.output,c).val(JSON.stringify(j))}function t(){m();g.fillStyle=a.bgColour;g.fillRect(0,0,i.width,i.height);if(!a.displayOnly&&a.lineWidth)g.beginPath(),g.lineWidth=a.lineWidth,g.strokeStyle=a.lineColour,g.moveTo(a.lineMargin,a.lineTop),g.lineTo(i.width-a.lineMargin,a.lineTop),g.stroke(),g.closePath();g.lineWidth=a.penWidth;g.strokeStyle=a.penColour;b(a.output,c).val("");j=[]}function y(d){q?h.each(function(){this.addEventListener("touchmove",
s,false)}):h.bind("mousemove.signaturepad",s);s(d,1)}function u(){w=false;q?h.each(function(){this.removeEventListener("touchstart",m);this.removeEventListener("touchend",m);this.removeEventListener("touchmove",s)}):(h.unbind("mousedown.signaturepad"),h.unbind("mouseup.signaturepad"),h.unbind("mousemove.signaturepad"),h.unbind("mouseleave.signaturepad"));b(a.clear,c).unbind("click.signaturepad")}function z(d){if(w)return false;w=true;typeof d.changedTouches!=="undefined"&&(q=true);q?(h.each(function(){this.addEventListener("touchend",
m,false);this.addEventListener("touchcancel",m,false)}),h.unbind("mousedown.signaturepad")):(h.bind("mouseup.signaturepad",function(){m()}),h.bind("mouseleave.signaturepad",function(){n||(n=setTimeout(function(){m();clearTimeout(n);n=false},500))}),h.each(function(){this.ontouchstart=null}))}function x(){b(a.typed,c).hide();t();h.each(function(){this.ontouchstart=function(d){d.preventDefault();z(d);y(d,this)}});h.bind("mousedown.signaturepad",function(d){z(d);y(d,this)});b(a.clear,c).bind("click.signaturepad",
function(d){d.preventDefault();t()});b(a.typeIt,c).bind("click.signaturepad",function(d){d.preventDefault();A()});b(a.drawIt,c).unbind("click.signaturepad");b(a.drawIt,c).bind("click.signaturepad",function(d){d.preventDefault()});b(a.typeIt,c).removeClass(a.currentClass);b(a.drawIt,c).addClass(a.currentClass);b(a.sig,c).addClass(a.currentClass);b(a.typeItDesc,c).hide();b(a.drawItDesc,c).show();b(a.clear,c).show()}function A(){t();u();b(a.typed,c).show();b(a.drawIt,c).bind("click.signaturepad",function(d){d.preventDefault();
x()});b(a.typeIt,c).unbind("click.signaturepad");b(a.typeIt,c).bind("click.signaturepad",function(d){d.preventDefault()});b(a.output,c).val("");b(a.drawIt,c).removeClass(a.currentClass);b(a.typeIt,c).addClass(a.currentClass);b(a.sig,c).removeClass(a.currentClass);b(a.drawItDesc,c).hide();b(a.clear,c).hide();b(a.typeItDesc,c).show()}function B(d){for(b(a.typed,c).html(d.replace(/>/g,"&gt;").replace(/</g,"&lt;"));b(a.typed,c).width()>i.width;)d=b(a.typed,c).css("font-size").replace(/px/,""),b(a.typed,
c).css("font-size",d-1+"px")}function E(d,a){b("p."+a.errorClass,d).remove();d.removeClass(a.errorClass);b("input, label",d).removeClass(a.errorClass)}function F(a,c,e){a.nameInvalid&&(c.prepend(['<p class="',e.errorClass,'">',e.errorMessage,"</p>"].join("")),b(e.name,c).focus(),b(e.name,c).addClass(e.errorClass),b("label[for="+b(e.name).attr("id")+"]",c).addClass(e.errorClass));a.drawInvalid&&c.prepend(['<p class="',e.errorClass,'">',e.errorMessageDraw,"</p>"].join(""))}function C(){var d=true,v=
{drawInvalid:false,nameInvalid:false},e=[c,a],f=[v,c,a];a.onBeforeValidate&&typeof a.onBeforeValidate==="function"?a.onBeforeValidate.apply(o,e):E.apply(o,e);if(a.drawOnly&&j.length<1)v.drawInvalid=true,d=false;if(b(a.name,c).val()==="")v.nameInvalid=true,d=false;a.onFormError&&typeof a.onFormError==="function"?a.onFormError.apply(o,f):F.apply(o,f);return d}function D(d,b,c){for(var f in d)if(typeof d[f]==="object")b.beginPath(),b.moveTo(d[f].mx,d[f].my),b.lineTo(d[f].lx,d[f].ly),b.lineCap=a.penCap,
b.stroke(),b.closePath(),c&&j.push({lx:d[f].lx,ly:d[f].ly,mx:d[f].mx,my:d[f].my})}function G(){if(parseFloat((/CPU.+OS ([0-9_]{3}).*AppleWebkit.*Mobile/i.exec(navigator.userAgent)||[0,"4_2"])[1].replace("_","."))<4.1)b.fn.Oldoffset=b.fn.offset,b.fn.offset=function(){var a=b(this).Oldoffset();a.top-=window.scrollY;a.left-=window.scrollX;return a};b(a.typed,c).bind("selectstart.signaturepad",function(a){return b(a.target).is(":input")});h.bind("selectstart.signaturepad",function(a){return b(a.target).is(":input")});
!i.getContext&&FlashCanvas&&FlashCanvas.initElement(i);i.getContext&&(g=i.getContext("2d"),b(a.sig,c).show(),a.displayOnly||(a.drawOnly||(b(a.name,c).bind("keyup.signaturepad",function(){B(b(this).val())}),b(a.name,c).bind("blur.signaturepad",function(){B(b(this).val())}),b(a.drawIt,c).bind("click.signaturepad",function(a){a.preventDefault();x()})),a.drawOnly||a.defaultAction==="drawIt"?x():A(),a.validateFields&&(b(r).is("form")?b(r).bind("submit.signaturepad",function(){return C()}):b(r).parents("form").bind("submit.signaturepad",
function(){return C()})),b(a.sigNav,c).show()))}var o=this,a=b.extend({},b.fn.signaturePad.defaults,p),c=b(r),h=b(a.canvas,c),i=h.get(0),g=null;k=null;l=null;var j=[],n=false,q=false,w=false;b.extend(o,{init:function(){G()},regenerate:function(d){o.clearCanvas();b(a.typed,c).hide();typeof d==="string"&&(d=JSON.parse(d));D(d,g,true);b(a.output,c).length>0&&b(a.output,c).val(JSON.stringify(j))},clearCanvas:function(){t()},getSignature:function(){return j},getSignatureString:function(){return JSON.stringify(j)},
getSignatureImage:function(){var b=document.createElement("canvas"),c=null,c=null;b.style.position="absolute";b.style.top="-999em";b.width=i.width;b.height=i.height;document.body.appendChild(b);!b.getContext&&FlashCanvas&&FlashCanvas.initElement(b);c=b.getContext("2d");c.fillStyle=a.bgColour;c.fillRect(0,0,i.width,i.height);c.lineWidth=a.penWidth;c.strokeStyle=a.penColour;D(j,c);c=b.toDataURL.apply(b,arguments);document.body.removeChild(b);return c}})}b.fn.signaturePad=function(b){var p=null;this.each(function(){p=
new u(this,b);p.init()});return p};b.fn.signaturePad.defaults={defaultAction:"typeIt",displayOnly:false,drawOnly:false,canvas:"canvas",sig:".sig",sigNav:".sigNav",bgColour:"#ffffff",penColour:"#145394",penWidth:2,penCap:"round",lineColour:"#ccc",lineWidth:2,lineMargin:5,lineTop:35,name:".name",typed:".typed",clear:".clearButton",typeIt:".typeIt a",drawIt:".drawIt a",typeItDesc:".typeItDesc",drawItDesc:".drawItDesc",output:".output",currentClass:"current",validateFields:true,errorClass:"error",errorMessage:"Please enter your name",
errorMessageDraw:"Please sign the document",onBeforeValidate:null,onFormError:null}})(jQuery);
